﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.Xml;
using System.ServiceModel.Activation;

namespace igDataSourceWCFService
{
    public class StockQuoteService : IStockQuoteService
    {
        public XmlElement GetStockQuoteGET(string symbol)
        {
            XmlDocument stockQuoteXmlDoc = new XmlDocument();
            string stockXmlData = string.Empty;

            switch (symbol)
            {
                case "MSFT":
                    stockXmlData =
                        "<StockQuotes>" +
                            "<Stock>" +
                                "<Symbol>MSFT</Symbol>" +
                                "<Last>28.08</Last>" +
                                "<Date>7/26/2011</Date>" +
                                "<Time>4:00pm</Time>" +
                                "<Change>0.00</Change>" +
                                "<Open>N/A</Open>" +
                                "<High>N/A</High>" +
                                "<Low>N/A</Low>" +
                                "<Volume>500</Volume>" +
                                "<MktCap>236.8B</MktCap>" +
                                "<PreviousClose>28.08</PreviousClose>" +
                                "<PercentageChange>0.00%</PercentageChange>" +
                                "<AnnRange>23.32 - 29.46</AnnRange>" +
                                "<Earns>2.517</Earns>" +
                                "<P-E>11.16</P-E>" +
                                "<Name>Microsoft Corporation</Name>" +
                            "</Stock>" +
                        "</StockQuotes>";
                    break;

                case "AAPL":
                    stockXmlData =
                        "<StockQuotes>" +
                            "<Stock>" +
                                "<Symbol>AAPL</Symbol>" +
                                "<Last>403.41</Last>" +
                                "<Date>7/26/2011</Date>" +
                                "<Time>4:00pm</Time>" +
                                "<Change>0.00</Change>" +
                                "<Open>N/A</Open>" +
                                "<High>N/A</High>" +
                                "<Low>N/A</Low>" +
                                "<Volume>7000</Volume>" +
                                "<MktCap>373.9B</MktCap>" +
                                "<PreviousClose>403.41</PreviousClose>" +
                                "<PercentageChange>0.00%</PercentageChange>" +
                                "<AnnRange>235.56 - 404.50</AnnRange>" +
                                "<Earns>25.277</Earns>" +
                                "<P-E>15.96</P-E>" +
                                "<Name>Apple Inc.</Name>" +
                            "</Stock>" +
                        "</StockQuotes>";
                    break;

                case "GOOG":
                    stockXmlData =
                        "<StockQuotes>" +
                            "<Stock>" +
                                "<Symbol>GOOG</Symbol>" +
                                "<Last>622.52</Last>" +
                                "<Date>7/26/2011</Date>" +
                                "<Time>4:00pm</Time>" +
                                "<Change>0.00</Change>" +
                                "<Open>N/A</Open>" +
                                "<High>N/A</High>" +
                                "<Low>N/A</Low>" +
                                "<Volume>0</Volume>" +
                                "<MktCap>200.6B</MktCap>" +
                                "<PreviousClose>622.52</PreviousClose>" +
                                "<PercentageChange>0.00%</PercentageChange>" +
                                "<AnnRange>447.65 - 642.96</AnnRange>" +
                                "<Earns>25.75</Earns>" +
                                "<P-E>24.18</P-E>" +
                                "<Name>Google Inc.</Name>" +
                            "</Stock>" +
                        "</StockQuotes>";
                    break;

                case "INTC":
                    stockXmlData =
                        "<StockQuotes>" +
                            "<Stock>" +
                                "<Symbol>INTC</Symbol>" +
                                "<Last>22.895</Last>" +
                                "<Date>7/26/2011</Date>" +
                                "<Time>4:00pm</Time>" +
                                "<Change>0.00</Change>" +
                                "<Open>N/A</Open>" +
                                "<High>N/A</High>" +
                                "<Low>N/A</Low>" +
                                "<Volume>1200</Volume>" +
                                "<MktCap>121.4B</MktCap>" +
                                "<PreviousClose>22.895</PreviousClose>" +
                                "<PercentageChange>0.00%</PercentageChange>" +
                                "<AnnRange>17.60 - 23.96</AnnRange>" +
                                "<Earns>2.139</Earns>" +
                                "<P-E>10.70</P-E>" +
                                "<Name>Intel Corporation</Name>" +
                            "</Stock>" +
                        "</StockQuotes>";
                    break;

                case "GE":
                    stockXmlData =
                        "<StockQuotes>" +
                            "<Stock>" +
                                "<Symbol>GE</Symbol>" +
                                "<Last>18.56</Last>" +
                                "<Date>7/26/2011</Date>" +
                                "<Time>4:01pm</Time>" +
                                "<Change>0.00</Change>" +
                                "<Open>N/A</Open>" +
                                "<High>N/A</High>" +
                                "<Low>N/A</Low>" +
                                "<Volume>1995</Volume>" +
                                "<MktCap>196.8B</MktCap>" +
                                "<PreviousClose>18.56</PreviousClose>" +
                                "<PercentageChange>0.00%</PercentageChange>" +
                                "<AnnRange>14.25 - 21.65</AnnRange>" +
                                "<Earns>1.199</Earns>" +
                                "<P-E>15.48</P-E>" +
                                "<Name>General Electric</Name>" +
                            "</Stock>" +
                        "</StockQuotes>";
                    break;

                default:
                    stockXmlData =
                        "<StockQuotes>" +
                            "<Stock>" +
                                "<Symbol>!!!</Symbol>" +
                                "<Name>No Information Found</Name>" +
                            "</Stock>" +
                        "</StockQuotes>";
                    break;
            }

            stockQuoteXmlDoc.LoadXml(stockXmlData);

            return stockQuoteXmlDoc.DocumentElement;
        }

    }
}
